#include "ShaderConstants.fxh"
#include "custom/presetSetting.fxh"
#include ".Assets/pre.function"

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
	float lpos : LPOS;
};

struct PS_Output
{
    float4 color : SV_Target;
};

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{
DetectTime at;
   at.rain = clamp((1.0-pow(FOG_CONTROL.y + 0.1, 5.0))*2.0, 0.0, 1.0);
   at.dusk = clamp(((1.5-FOG_COLOR.r*2.0)+(1.0-FOG_COLOR.b))*(1.0-dot(FOG_COLOR.rgb, float3(0.35, 0.35, 0.35)))*FOG_COLOR.g*2.0, 0.0, 1.0)*(1.0-at.rain);
   at.night = clamp(1.0-FOG_COLOR.g*(1.5-at.dusk)*2.5, 0.0, 1.0);

   float4 sColor = PSInput.color, g0 = lerp(lerp(lerp(FOG_COLOR, FOG_COLOR, at.dusk), FOG_COLOR, at.night), FOG_COLOR, at.rain);

   float4 g1 = lerp(lerp(lerp(FOG_COLOR, FOG_COLOR*float4(2.0, 1.0, 1.0, 1.0), at.dusk), FOG_COLOR, at.night), FOG_COLOR, at.rain);
   float4 g2 = lerp(lerp(lerp(FOG_COLOR, float4(1.4, 0.9, 0.8, 1.0), at.dusk), float4(0.1, 0.15, 0.25, 1.0), at.night), FOG_COLOR, at.rain);
   float4 g3 = lerp(lerp(lerp(FOG_COLOR, float4(1.1, 0.8, 0.7, 1.0), at.dusk), float4(0.07, 0.11, 0.24, 1.0), at.night), FOG_COLOR*1.1, at.rain);
   float4 g4 = lerp(lerp(lerp(FOG_COLOR, float4(0.9, 0.7, 0.8, 1.0), at.dusk), float4(0.04, 0.08, 0.15, 1.0), at.night), FOG_COLOR*1.16, at.rain);
   float4 g5 = lerp(lerp(lerp(FOG_COLOR, float4(0.8, 0.6, 0.7, 1.0), at.dusk), float4(0.015, 0.025, 0.1, 1.0), at.night), FOG_COLOR*1.2, at.rain);
   float4 g6 = lerp(lerp(lerp(FOG_COLOR, float4(0.6, 0.5, 0.8, 1.0), at.dusk), float4(0.07, 0.11, 0.23, 1.0), at.night), FOG_COLOR*1.23, at.rain);
   float4 g7 = lerp(lerp(lerp(FOG_COLOR, float4(0.4, 0.3, 0.7, 1.0), at.dusk), float4(0.04, 0.08, 0.15, 1.0), at.night), FOG_COLOR*1.25, at.rain);
   float4 g8 = lerp(lerp(lerp(FOG_COLOR, float4(0.3, 0.2, 0.6, 1.0), at.dusk), float4(0.015, 0.025, 0.1, 1.0), at.night), FOG_COLOR*1.28, at.rain);
   float4 g9 = lerp(lerp(lerp(FOG_COLOR, float4(0.0, 0.0, 0.5, 1.0), at.dusk), float4(0.015, 0.025, 0.1, 1.0), at.night), FOG_COLOR*1.3, at.rain);

   sColor = lerp(daCs, duCs, at.dusk);
   sColor = lerp(sColor, niCs, at.night);
   sColor = lerp(sColor, lerp(radaCs, raniCs, at.night), at.rain);

   sColor = lerp(sColor, g9, pow(clamp(PSInput.lpos*1.83, 0.0, 1.0), 2.3));
   sColor = lerp(sColor, g8, pow(clamp(PSInput.lpos*1.77, 0.0, 1.0), 2.2));
   sColor = lerp(sColor, g7, pow(clamp(PSInput.lpos*1.73, 0.0, 1.0), 2.1));
   sColor = lerp(sColor, g6, pow(clamp(PSInput.lpos*1.69, 0.0, 1.0), 2.2));
   sColor = lerp(sColor, g5, pow(clamp(PSInput.lpos*1.68, 0.0, 1.0), 2.3));
   sColor = lerp(sColor, g4, pow(clamp(PSInput.lpos*1.66, 0.0, 1.0), 2.4));
   sColor = lerp(sColor, g3, pow(clamp(PSInput.lpos*1.65, 0.0, 1.0), 2.5));
   sColor = lerp(sColor, g2, pow(clamp(PSInput.lpos*1.63, 0.0, 1.0), 2.4));
   sColor = lerp(sColor, g1, pow(clamp(PSInput.lpos*1.23, 0.0, 1.0), 1.8));
   sColor = lerp(sColor, g0, pow(clamp(PSInput.lpos*1.04, 0.0, 1.0), 1.1));

   PSOutput.color = sColor;
}